/* Questo sketch permette di disegnare un manipolatore planare a 
due link e di muoverlo mediante le frecce destra e sinistra, dopo 
aver selezionato il giunto che si intende muovere con i tasti 1 e 
2. Le frecce SU e GIÙ permettono di variare la velocità. */

float x,y;
float[] theta = new float[2];
int giunto = 1;
float velocita = .1;
int fineCorsa = 0;
float L1 = 100; // lunghezza primo link
float L2 = 70; // lunghezza secondo link  

void setup() 
{
  size(600, 400);
  smooth();
  theta[0] = 0;
  theta[1] = PI/2;
  x = width/2;
  y = height/2;
}

void draw() 
{
  background(204);
  if (keyPressed)
  {
    if (key == '1')
    {
      giunto = 1;
    }
    if (key == '2')
    {
      giunto = 2;
    }
    if (keyCode == RIGHT)
    {
      if ((giunto == 2) && (theta[giunto-1] < -160*PI/180))
      {
        fineCorsa = 1;
      }
      else
      {
        fineCorsa = 0;
      }
      theta[giunto-1] -= (1-fineCorsa)*velocita;
    }
    if (keyCode == LEFT)
    {
      if ((giunto == 2) && (theta[giunto-1] > 160*PI/180))
      {
        fineCorsa = 1;
      }
      else
      {
        fineCorsa = 0;
      }
      theta[giunto-1] += (1-fineCorsa)*velocita;
    }
    if (keyCode == UP)
    {
      velocita += .001;
      if (velocita > .2)
      {
        velocita = .2;
      }
    }
    if (keyCode == DOWN)
    {
      velocita -= .001;
      if (velocita < 0.005)
      {
        velocita = 0.005;
      }
    }
  }    
  robot(x,y,theta[0],theta[1]);
  textSize(15);
  text("velocita = ",width-180,height-20); 
  text(velocita,width-100,height-20);
}

void robot(float x, float y, float theta1, float theta2)
{
  // Qui le coordinate si riferiscono allo schermo: (0,0) = in alto a sinistra
  // coordinate grafiche primo giunto
  float x1 = x+L1*cos(theta1);
  float y1 = y-L1*sin(theta1);  // Il meno per la convenzione grafica della y positiva verso il basso
  // coordinate grafiche secondo giunto  
  float x2 = x1+L2*cos(theta1+theta2);
  float y2 = y1-L2*sin(theta1+theta2);  
  
  noStroke();
  fill(0);
  // disegno base (nera)
  rect(x-15,y-15,30,30);
  //rect(x-15,y-15,30,30,5); // con bordi arrotondati
  fill(255,0,0);
  
  // disegno giunti (rossi)
  ellipse(x,y,15,15);
//  fill(255,0,0);
  ellipse(x1,y1,15,15);

// Disegno i due link
  stroke(0);
  strokeWeight(8);
  line(x,y,x1,y1);
  line(x1,y1,x2,y2);
  
// Disegno la pinza
  float xPuntoP1 = x2-7*sin(theta1+theta2);
  float yPuntoP1 = y2-7*cos(theta1+theta2);  
  float xPuntoP2 = x2+7*sin(theta1+theta2);
  float yPuntoP2 = y2+7*cos(theta1+theta2);  
  float xPuntoP11 = xPuntoP1+8*cos(theta1+theta2);
  float yPuntoP11 = yPuntoP1-8*sin(theta1+theta2);
  float xPuntoP22 = xPuntoP2+8*cos(theta1+theta2);
  float yPuntoP22 = yPuntoP2-8*sin(theta1+theta2);
  line(xPuntoP1,yPuntoP1,xPuntoP2,yPuntoP2);
  line(xPuntoP1,yPuntoP1,xPuntoP11,yPuntoP11);
  line(xPuntoP2,yPuntoP2,xPuntoP22,yPuntoP22);
}