/* Questo sketch disegna una sfera che si muove rimbalzando sul 
terreno. La sfera rimbalza anche quando arriva a impattare sulle 
pareti laterali. La sfera cambia colore casualmente ad ogni 
rimbalzo laterale. Il numero di rimbalzi viene contato e 
visualizzato. N.B. La soluzione implementata in questo sketch non
è robusta (a differenza dell'altra proposta) rispetto ad eventuali 
errori di misura della posizione x della sfera (scommentare la riga 
37 per verificarlo): in alcuni casi, in presenza di errore di misura, 
la pallina cambia verso più di una volta quando raggiunge un bordo. */

float diametro = 50; // diametro sfera
float x = diametro/2+1; // coordinata x della sfera
float y = 100; // coordinata y della sfera
float vX = 10; // velocità orizzontale sfera
float vY = -10; // velocità verticale sfera
int counter=0;
float xMisurato;
float erroreMisura = 0;

void setup() 
{
  size(1200, 700);
  smooth();
  fill(random(0,255),random(0,255),random(0,255));
}

void draw() 
{
  background(204); // disegna sfondo con livello di grigio 204
  if (mousePressed)
  {
    x = mouseX;
    y = mouseY;
  }
  
// Scommentare la seguente riga per testare il codice in presenza di un errore di misura sulla x
  //erroreMisura = random(-100,100);
  xMisurato = x + erroreMisura;
  if (xMisurato > width-diametro/2 || xMisurato < diametro/2) // la sfera è uscita dalla finestra
  {
    vX = -vX;
    fill(random(0,255),random(0,255),random(0,255));
    counter++;       
  }
  x=x+vX;
  if (y < height-diametro/2) // la sfera non ha ancora toccato terra
  {
    vY = vY + 1;    // aumento velocità verticale per accelerazione di gravità
  }
  else // la sfera tocca terra
  {
    vY = - vY; // rimbalzo
  }
  y = y + vY;  // aggiornamento posizione verticale
    
  textSize(30);
  text(counter,50,50);
  ellipse(x, y, diametro, diametro); // disegno la sfera
}